import { BMapLoaderService } from './bmap-loader.service';
import { Directive, Input, ElementRef, NgZone } from '@angular/core';
var BMapDirective = /** @class */ (function () {
    function BMapDirective(elementRef, loader, zone) {
        this.elementRef = elementRef;
        this.loader = loader;
        this.zone = zone;
    }
    BMapDirective.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.loader.load().then(function () {
            var map = _this.map = _this.zone.runOutsideAngular(function () {
                return new BMap.Map(_this.elementRef.nativeElement, {
                    enableMapClick: false
                });
            });
        });
    };
    BMapDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[bmap]',
                },] },
    ];
    /** @nocollapse */
    BMapDirective.ctorParameters = function () { return [
        { type: ElementRef, },
        { type: BMapLoaderService, },
        { type: NgZone, },
    ]; };
    BMapDirective.propDecorators = {
        'center': [{ type: Input },],
        'zoom': [{ type: Input },],
    };
    return BMapDirective;
}());
export { BMapDirective };
//# sourceMappingURL=bmap.directive.js.map